/* Include files */

#include "blascompat32.h"
#include "stopwatch_sfun.h"
#include "c1_stopwatch.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "stopwatch_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_event_tick                  (0)
#define c1_IN_NO_ACTIVE_CHILD          (0)
#define c1_IN_Stopped                  (2)
#define c1_IN_Started                  (1)
#define c1_IN_Count                    (1)
#define c1_IN_Engaged                  (2)
#define c1_IN_Disengaged               (1)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_stopwatchInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_stopwatch(void);
static void initialize_params_c1_stopwatch(void);
static void enable_c1_stopwatch(void);
static void disable_c1_stopwatch(void);
static void c1_update_debugger_state_c1_stopwatch(void);
static const mxArray *get_sim_state_c1_stopwatch(void);
static void set_sim_state_c1_stopwatch(const mxArray *c1_st);
static void c1_set_sim_state_side_effects_c1_stopwatch(void);
static void finalize_c1_stopwatch(void);
static void sf_c1_stopwatch(void);
static void c1_chartstep_c1_stopwatch(void);
static void c1_Count(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_c_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_d_sf_marshall(void *c1_chartInstance, void *c1_u);
static uint32_T c1__u32_add__(uint32_T c1_b, uint32_T c1_c);
static uint8_T c1__u8_add__(uint8_T c1_b, uint8_T c1_c);
static uint32_T c1__u32_s8_(int8_T c1_b);
static uint8_T c1__u8_s8_(int8_T c1_b);
static void init_test_point_addr_map(void);
static void **get_test_point_address_map(void);
static rtwCAPI_ModelMappingInfo *get_test_point_mapping_info(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_stopwatch(void)
{
  real_T *c1_minutes_out;
  real_T *c1_seconds_out;
  c1_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_doSetSimStateSideEffects = 0U;
  chartInstance.c1_setSimStateSideEffectsInfo = NULL;
  chartInstance.c1_is_active_Memory = 0U;
  chartInstance.c1_is_Memory = 0U;
  chartInstance.c1_tp_Memory = 0U;
  chartInstance.c1_tp_Disengaged = 0U;
  chartInstance.c1_tp_Engaged = 0U;
  chartInstance.c1_is_active_Watch = 0U;
  chartInstance.c1_is_Watch = 0U;
  chartInstance.c1_tp_Watch = 0U;
  chartInstance.c1_is_Started = 0U;
  chartInstance.c1_tp_Started = 0U;
  chartInstance.c1_tp_Count = 0U;
  chartInstance.c1_tp_Stopped = 0U;
  chartInstance.c1_is_active_c1_stopwatch = 0U;
  chartInstance.c1_seconds = 0U;
  chartInstance.c1_minutes = 0U;
  chartInstance.c1_mem_seconds = 0U;
  chartInstance.c1_mem_minutes = 0U;
  if (!(cdrGetOutputPortReusable(chartInstance.S, 1) != 0)) {
    *c1_minutes_out = 0.0;
  }

  if (!(cdrGetOutputPortReusable(chartInstance.S, 2) != 0)) {
    *c1_seconds_out = 0.0;
  }
}

static void initialize_params_c1_stopwatch(void)
{
}

static void enable_c1_stopwatch(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c1_stopwatch(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c1_update_debugger_state_c1_stopwatch(void)
{
  uint32_T c1_prevAniVal;
  c1_prevAniVal = sf_debug_get_animation();
  sf_debug_set_animation(0U);
  if ((int16_T)chartInstance.c1_is_active_c1_stopwatch == 1) {
    _SFD_CC_CALL(CHART_ACTIVE_TAG,0);
  }

  if ((int16_T)chartInstance.c1_is_Watch == c1_IN_Stopped) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,6);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,6);
  }

  if ((int16_T)chartInstance.c1_is_Watch == c1_IN_Started) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,4);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,4);
  }

  if ((int16_T)chartInstance.c1_is_Started == c1_IN_Count) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,5);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,5);
  }

  if ((int16_T)chartInstance.c1_is_active_Watch == 1) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,3);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,3);
  }

  if ((int16_T)chartInstance.c1_is_active_Memory == 1) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,0);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,0);
  }

  if ((int16_T)chartInstance.c1_is_Memory == c1_IN_Engaged) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,2);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,2);
  }

  if ((int16_T)chartInstance.c1_is_Memory == c1_IN_Disengaged) {
    _SFD_CS_CALL(STATE_ACTIVE_TAG,1);
  } else {
    _SFD_CS_CALL(STATE_INACTIVE_TAG,1);
  }

  sf_debug_set_animation(c1_prevAniVal);
  _SFD_ANIMATE();
}

static const mxArray *get_sim_state_c1_stopwatch(void)
{
  const mxArray *c1_st = NULL;
  const mxArray *c1_y = NULL;
  real_T c1_u;
  const mxArray *c1_b_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_c_y = NULL;
  uint32_T c1_c_u;
  const mxArray *c1_d_y = NULL;
  uint8_T c1_d_u;
  const mxArray *c1_e_y = NULL;
  uint32_T c1_e_u;
  const mxArray *c1_f_y = NULL;
  uint8_T c1_f_u;
  const mxArray *c1_g_y = NULL;
  uint8_T c1_g_u;
  const mxArray *c1_h_y = NULL;
  uint8_T c1_h_u;
  const mxArray *c1_i_y = NULL;
  uint8_T c1_i_u;
  const mxArray *c1_j_y = NULL;
  uint8_T c1_j_u;
  const mxArray *c1_k_y = NULL;
  uint8_T c1_k_u;
  const mxArray *c1_l_y = NULL;
  uint8_T c1_l_u;
  const mxArray *c1_m_y = NULL;
  real_T *c1_minutes_out;
  real_T *c1_seconds_out;
  c1_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(12));
  c1_u = *c1_minutes_out;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 0, c1_b_y);
  c1_b_u = *c1_seconds_out;
  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 1, c1_c_y);
  c1_c_u = chartInstance.c1_mem_minutes;
  c1_d_y = NULL;
  sf_mex_assign(&c1_d_y, sf_mex_create("y", &c1_c_u, 7, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 2, c1_d_y);
  c1_d_u = chartInstance.c1_mem_seconds;
  c1_e_y = NULL;
  sf_mex_assign(&c1_e_y, sf_mex_create("y", &c1_d_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 3, c1_e_y);
  c1_e_u = chartInstance.c1_minutes;
  c1_f_y = NULL;
  sf_mex_assign(&c1_f_y, sf_mex_create("y", &c1_e_u, 7, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 4, c1_f_y);
  c1_f_u = chartInstance.c1_seconds;
  c1_g_y = NULL;
  sf_mex_assign(&c1_g_y, sf_mex_create("y", &c1_f_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 5, c1_g_y);
  c1_g_u = chartInstance.c1_is_active_c1_stopwatch;
  c1_h_y = NULL;
  sf_mex_assign(&c1_h_y, sf_mex_create("y", &c1_g_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 6, c1_h_y);
  c1_h_u = chartInstance.c1_is_active_Watch;
  c1_i_y = NULL;
  sf_mex_assign(&c1_i_y, sf_mex_create("y", &c1_h_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 7, c1_i_y);
  c1_i_u = chartInstance.c1_is_active_Memory;
  c1_j_y = NULL;
  sf_mex_assign(&c1_j_y, sf_mex_create("y", &c1_i_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 8, c1_j_y);
  c1_j_u = chartInstance.c1_is_Started;
  c1_k_y = NULL;
  sf_mex_assign(&c1_k_y, sf_mex_create("y", &c1_j_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 9, c1_k_y);
  c1_k_u = chartInstance.c1_is_Watch;
  c1_l_y = NULL;
  sf_mex_assign(&c1_l_y, sf_mex_create("y", &c1_k_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 10, c1_l_y);
  c1_l_u = chartInstance.c1_is_Memory;
  c1_m_y = NULL;
  sf_mex_assign(&c1_m_y, sf_mex_create("y", &c1_l_u, 3, 0U, 0U, 0U, 0));
  sf_mex_setcell(c1_y, 11, c1_m_y);
  sf_mex_assign(&c1_st, c1_y);
  return c1_st;
}

static void set_sim_state_c1_stopwatch(const mxArray *c1_st)
{
  const mxArray *c1_u;
  const mxArray *c1_minutes_out;
  real_T c1_d0;
  real_T c1_y;
  const mxArray *c1_b_minutes_out;
  real_T c1_d1;
  real_T c1_b_y;
  const mxArray *c1_b_mem_minutes;
  uint32_T c1_u0;
  uint32_T c1_c_y;
  const mxArray *c1_b_mem_seconds;
  uint8_T c1_u1;
  uint8_T c1_d_y;
  const mxArray *c1_c_mem_minutes;
  uint32_T c1_u2;
  uint32_T c1_e_y;
  const mxArray *c1_c_mem_seconds;
  uint8_T c1_u3;
  uint8_T c1_f_y;
  const mxArray *c1_d_mem_seconds;
  uint8_T c1_u4;
  uint8_T c1_g_y;
  const mxArray *c1_e_mem_seconds;
  uint8_T c1_u5;
  uint8_T c1_h_y;
  const mxArray *c1_f_mem_seconds;
  uint8_T c1_u6;
  uint8_T c1_i_y;
  const mxArray *c1_g_mem_seconds;
  uint8_T c1_u7;
  uint8_T c1_j_y;
  const mxArray *c1_h_mem_seconds;
  uint8_T c1_u8;
  uint8_T c1_k_y;
  const mxArray *c1_i_mem_seconds;
  uint8_T c1_u9;
  uint8_T c1_l_y;
  const mxArray *c1_b_setSimStateSideEffectsInfo;
  const mxArray *c1_m_y = NULL;
  real_T *c1_c_minutes_out;
  real_T *c1_seconds_out;
  c1_c_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_u = sf_mex_dup(c1_st);
  c1_minutes_out = sf_mex_dup(sf_mex_getcell(c1_u, 0));
  sf_mex_import("minutes_out", sf_mex_dup(c1_minutes_out), &c1_d0, 1, 0, 0U, 0,
                0U, 0);
  c1_y = c1_d0;
  sf_mex_destroy(&c1_minutes_out);
  *c1_c_minutes_out = c1_y;
  c1_b_minutes_out = sf_mex_dup(sf_mex_getcell(c1_u, 1));
  sf_mex_import("seconds_out", sf_mex_dup(c1_b_minutes_out), &c1_d1, 1, 0, 0U, 0,
                0U, 0);
  c1_b_y = c1_d1;
  sf_mex_destroy(&c1_b_minutes_out);
  *c1_seconds_out = c1_b_y;
  c1_b_mem_minutes = sf_mex_dup(sf_mex_getcell(c1_u, 2));
  sf_mex_import("mem_minutes", sf_mex_dup(c1_b_mem_minutes), &c1_u0, 1, 7, 0U, 0,
                0U, 0);
  c1_c_y = c1_u0;
  sf_mex_destroy(&c1_b_mem_minutes);
  chartInstance.c1_mem_minutes = c1_c_y;
  c1_b_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 3));
  sf_mex_import("mem_seconds", sf_mex_dup(c1_b_mem_seconds), &c1_u1, 1, 3, 0U, 0,
                0U, 0);
  c1_d_y = c1_u1;
  sf_mex_destroy(&c1_b_mem_seconds);
  chartInstance.c1_mem_seconds = c1_d_y;
  c1_c_mem_minutes = sf_mex_dup(sf_mex_getcell(c1_u, 4));
  sf_mex_import("minutes", sf_mex_dup(c1_c_mem_minutes), &c1_u2, 1, 7, 0U, 0, 0U,
                0);
  c1_e_y = c1_u2;
  sf_mex_destroy(&c1_c_mem_minutes);
  chartInstance.c1_minutes = c1_e_y;
  c1_c_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 5));
  sf_mex_import("seconds", sf_mex_dup(c1_c_mem_seconds), &c1_u3, 1, 3, 0U, 0, 0U,
                0);
  c1_f_y = c1_u3;
  sf_mex_destroy(&c1_c_mem_seconds);
  chartInstance.c1_seconds = c1_f_y;
  c1_d_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 6));
  sf_mex_import("is_active_c1_stopwatch", sf_mex_dup(c1_d_mem_seconds), &c1_u4,
                1, 3, 0U, 0, 0U, 0);
  c1_g_y = c1_u4;
  sf_mex_destroy(&c1_d_mem_seconds);
  chartInstance.c1_is_active_c1_stopwatch = c1_g_y;
  c1_e_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 7));
  sf_mex_import("is_active_Watch", sf_mex_dup(c1_e_mem_seconds), &c1_u5, 1, 3,
                0U, 0, 0U, 0);
  c1_h_y = c1_u5;
  sf_mex_destroy(&c1_e_mem_seconds);
  chartInstance.c1_is_active_Watch = c1_h_y;
  c1_f_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 8));
  sf_mex_import("is_active_Memory", sf_mex_dup(c1_f_mem_seconds), &c1_u6, 1, 3,
                0U, 0, 0U, 0);
  c1_i_y = c1_u6;
  sf_mex_destroy(&c1_f_mem_seconds);
  chartInstance.c1_is_active_Memory = c1_i_y;
  c1_g_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 9));
  sf_mex_import("is_Started", sf_mex_dup(c1_g_mem_seconds), &c1_u7, 1, 3, 0U, 0,
                0U, 0);
  c1_j_y = c1_u7;
  sf_mex_destroy(&c1_g_mem_seconds);
  chartInstance.c1_is_Started = c1_j_y;
  c1_h_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 10));
  sf_mex_import("is_Watch", sf_mex_dup(c1_h_mem_seconds), &c1_u8, 1, 3, 0U, 0,
                0U, 0);
  c1_k_y = c1_u8;
  sf_mex_destroy(&c1_h_mem_seconds);
  chartInstance.c1_is_Watch = c1_k_y;
  c1_i_mem_seconds = sf_mex_dup(sf_mex_getcell(c1_u, 11));
  sf_mex_import("is_Memory", sf_mex_dup(c1_i_mem_seconds), &c1_u9, 1, 3, 0U, 0,
                0U, 0);
  c1_l_y = c1_u9;
  sf_mex_destroy(&c1_i_mem_seconds);
  chartInstance.c1_is_Memory = c1_l_y;
  c1_b_setSimStateSideEffectsInfo = sf_mex_dup(sf_mex_getcell(c1_u, 12));
  c1_m_y = NULL;
  sf_mex_assign(&c1_m_y, sf_mex_duplicatearraysafe
                (&c1_b_setSimStateSideEffectsInfo));
  sf_mex_destroy(&c1_b_setSimStateSideEffectsInfo);
  sf_mex_assign(&chartInstance.c1_setSimStateSideEffectsInfo, c1_m_y);
  sf_mex_destroy(&c1_u);
  chartInstance.c1_doSetSimStateSideEffects = 1U;
  c1_update_debugger_state_c1_stopwatch();
  sf_mex_destroy(&c1_st);
}

static void c1_set_sim_state_side_effects_c1_stopwatch(void)
{
  if (chartInstance.c1_doSetSimStateSideEffects != 0) {
    if ((int16_T)chartInstance.c1_is_active_Watch == 1) {
      chartInstance.c1_tp_Watch = 1U;
    } else {
      chartInstance.c1_tp_Watch = 0U;
    }

    if ((int16_T)chartInstance.c1_is_Watch == c1_IN_Started) {
      chartInstance.c1_tp_Started = 1U;
    } else {
      chartInstance.c1_tp_Started = 0U;
    }

    if ((int16_T)chartInstance.c1_is_Started == c1_IN_Count) {
      chartInstance.c1_tp_Count = 1U;
    } else {
      chartInstance.c1_tp_Count = 0U;
    }

    if ((int16_T)chartInstance.c1_is_Watch == c1_IN_Stopped) {
      chartInstance.c1_tp_Stopped = 1U;
    } else {
      chartInstance.c1_tp_Stopped = 0U;
    }

    if ((int16_T)chartInstance.c1_is_active_Memory == 1) {
      chartInstance.c1_tp_Memory = 1U;
    } else {
      chartInstance.c1_tp_Memory = 0U;
    }

    if ((int16_T)chartInstance.c1_is_Memory == c1_IN_Disengaged) {
      chartInstance.c1_tp_Disengaged = 1U;
    } else {
      chartInstance.c1_tp_Disengaged = 0U;
    }

    if ((int16_T)chartInstance.c1_is_Memory == c1_IN_Engaged) {
      chartInstance.c1_tp_Engaged = 1U;
    } else {
      chartInstance.c1_tp_Engaged = 0U;
    }

    chartInstance.c1_doSetSimStateSideEffects = 0U;
  }
}

static void finalize_c1_stopwatch(void)
{
  sf_mex_destroy(&chartInstance.c1_setSimStateSideEffectsInfo);
}

static void sf_c1_stopwatch(void)
{
  int32_T c1_previousEvent;
  real_T *c1_run;
  real_T *c1_minutes_out;
  real_T *c1_seconds_out;
  real_T *c1_lap;
  real_T *c1_store_recall;
  c1_lap = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_run = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_store_recall = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_set_sim_state_side_effects_c1_stopwatch();
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  _SFD_DATA_RANGE_CHECK(*c1_run, 0U);
  _SFD_DATA_RANGE_CHECK(*c1_minutes_out, 1U);
  _SFD_DATA_RANGE_CHECK_MIN_MAX(*c1_seconds_out, 2U, 0.0, 59.0);
  _SFD_DATA_RANGE_CHECK(*c1_lap, 3U);
  _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
  _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_minutes, 5U);
  _SFD_DATA_RANGE_CHECK_MIN_MAX((real_T)chartInstance.c1_mem_seconds, 6U, 0.0,
    59.0);
  _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_mem_minutes, 7U);
  _SFD_DATA_RANGE_CHECK(*c1_store_recall, 8U);
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_tick;
  _SFD_CE_CALL(EVENT_BEFORE_BROADCAST_TAG,c1_event_tick);
  c1_chartstep_c1_stopwatch();
  _SFD_CE_CALL(EVENT_AFTER_BROADCAST_TAG,c1_event_tick);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_stopwatchMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void c1_chartstep_c1_stopwatch(void)
{
  real_T *c1_store_recall;
  real_T *c1_seconds_out;
  real_T *c1_minutes_out;
  real_T *c1_run;
  c1_run = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_store_recall = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  if ((int16_T)chartInstance.c1_is_active_c1_stopwatch == 0) {
    _SFD_CC_CALL(CHART_ENTER_ENTRY_FUNCTION_TAG,0);
    chartInstance.c1_is_active_c1_stopwatch = 1U;
    _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
    chartInstance.c1_is_active_Watch = 1U;
    _SFD_CS_CALL(STATE_ACTIVE_TAG,3);
    chartInstance.c1_tp_Watch = 1U;
    _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,0);
    _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,0);
    chartInstance.c1_is_Watch = (uint8_T)c1_IN_Stopped;
    _SFD_CS_CALL(STATE_ACTIVE_TAG,6);
    chartInstance.c1_tp_Stopped = 1U;
    chartInstance.c1_is_active_Memory = 1U;
    _SFD_CS_CALL(STATE_ACTIVE_TAG,0);
    chartInstance.c1_tp_Memory = 1U;
    _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,12);
    _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,12);
    _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,10);
    if (CV_TRANSITION_EVAL(10U, (int32_T)_SFD_CCP_CALL(10,0,((*c1_store_recall
            != 0.0)!=0))) != 0) {
      _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,10);
      chartInstance.c1_is_Memory = (uint8_T)c1_IN_Engaged;
      _SFD_CS_CALL(STATE_ACTIVE_TAG,2);
      chartInstance.c1_tp_Engaged = 1U;
    } else {
      _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,11);
      _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,11);
      chartInstance.c1_is_Memory = (uint8_T)c1_IN_Disengaged;
      _SFD_CS_CALL(STATE_ACTIVE_TAG,1);
      chartInstance.c1_tp_Disengaged = 1U;
    }
  } else {
    _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,3);
    switch (chartInstance.c1_is_Watch) {
     case c1_IN_Started:
      CV_STATE_EVAL(3,0,1);
      _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,4);
      _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,2);
      if (CV_TRANSITION_EVAL(2U, (int32_T)!(_SFD_CCP_CALL(2,0,((*c1_run != 0.0)
              !=0)) != 0)) != 0) {
        _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,2);
        _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,5);
        chartInstance.c1_tp_Count = 0U;
        chartInstance.c1_is_Started = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
        _SFD_CS_CALL(STATE_INACTIVE_TAG,5);
        _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,5);
        _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,4);
        chartInstance.c1_tp_Started = 0U;
        _SFD_CS_CALL(STATE_INACTIVE_TAG,4);
        _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,4);
        chartInstance.c1_is_Watch = (uint8_T)c1_IN_Stopped;
        _SFD_CS_CALL(STATE_ACTIVE_TAG,6);
        chartInstance.c1_tp_Stopped = 1U;
      } else {
        c1_Count();
      }

      _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,4);
      break;

     case c1_IN_Stopped:
      CV_STATE_EVAL(3,0,2);
      _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,6);
      _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,1);
      if (CV_TRANSITION_EVAL(1U, (int32_T)_SFD_CCP_CALL(1,0,((*c1_run != 0.0)!=0)))
          != 0) {
        _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,1);
        _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,6);
        chartInstance.c1_tp_Stopped = 0U;
        _SFD_CS_CALL(STATE_INACTIVE_TAG,6);
        _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,6);
        chartInstance.c1_minutes = 0U;
        _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_minutes, 5U);
        *c1_minutes_out = 0.0;
        _SFD_DATA_RANGE_CHECK(*c1_minutes_out, 1U);
        chartInstance.c1_seconds = 0U;
        _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
        *c1_seconds_out = 0.0;
        _SFD_DATA_RANGE_CHECK_MIN_MAX(*c1_seconds_out, 2U, 0.0, 59.0);
        chartInstance.c1_is_Watch = (uint8_T)c1_IN_Started;
        _SFD_CS_CALL(STATE_ACTIVE_TAG,4);
        chartInstance.c1_tp_Started = 1U;
        _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,7);
        _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,7);
        chartInstance.c1_is_Started = (uint8_T)c1_IN_Count;
        _SFD_CS_CALL(STATE_ACTIVE_TAG,5);
        chartInstance.c1_tp_Count = 1U;
      }

      _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,6);
      break;

     default:
      CV_STATE_EVAL(3,0,0);
      chartInstance.c1_is_Watch = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      _SFD_CS_CALL(STATE_INACTIVE_TAG,4);
      break;
    }

    _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,3);
    _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,0);
    switch (chartInstance.c1_is_Memory) {
     case c1_IN_Disengaged:
      CV_STATE_EVAL(0,0,1);
      _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,1);
      _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,9);
      if (CV_TRANSITION_EVAL(9U, (int32_T)_SFD_CCP_CALL(9,0,((*c1_store_recall
              != 0.0)!=0))) != 0) {
        _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,9);
        _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,1);
        chartInstance.c1_tp_Disengaged = 0U;
        _SFD_CS_CALL(STATE_INACTIVE_TAG,1);
        _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
        chartInstance.c1_mem_seconds = chartInstance.c1_seconds;
        _SFD_DATA_RANGE_CHECK_MIN_MAX((real_T)chartInstance.c1_mem_seconds, 6U,
          0.0, 59.0);
        chartInstance.c1_mem_minutes = chartInstance.c1_minutes;
        _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_mem_minutes, 7U);
        chartInstance.c1_is_Memory = (uint8_T)c1_IN_Engaged;
        _SFD_CS_CALL(STATE_ACTIVE_TAG,2);
        chartInstance.c1_tp_Engaged = 1U;
      }

      _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
      break;

     case c1_IN_Engaged:
      CV_STATE_EVAL(0,0,2);
      _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,2);
      _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,8);
      if (CV_TRANSITION_EVAL(8U, (int32_T)!(_SFD_CCP_CALL(8,0,((*c1_store_recall
               != 0.0)!=0)) != 0)) != 0) {
        _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,8);
        _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,2);
        chartInstance.c1_tp_Engaged = 0U;
        _SFD_CS_CALL(STATE_INACTIVE_TAG,2);
        _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,2);
        chartInstance.c1_seconds = chartInstance.c1_mem_seconds;
        _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
        chartInstance.c1_minutes = chartInstance.c1_mem_minutes;
        _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_minutes, 5U);
        *c1_seconds_out = (real_T)chartInstance.c1_mem_seconds;
        _SFD_DATA_RANGE_CHECK_MIN_MAX(*c1_seconds_out, 2U, 0.0, 59.0);
        *c1_minutes_out = (real_T)chartInstance.c1_mem_minutes;
        _SFD_DATA_RANGE_CHECK(*c1_minutes_out, 1U);
        chartInstance.c1_is_Memory = (uint8_T)c1_IN_Disengaged;
        _SFD_CS_CALL(STATE_ACTIVE_TAG,1);
        chartInstance.c1_tp_Disengaged = 1U;
      }

      _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,2);
      break;

     default:
      CV_STATE_EVAL(0,0,0);
      chartInstance.c1_is_Memory = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      _SFD_CS_CALL(STATE_INACTIVE_TAG,1);
      break;
    }

    _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
}

static void c1_Count(void)
{
  boolean_T c1_temp;
  boolean_T c1_b_temp;
  boolean_T c1_c_temp;
  boolean_T c1_d_temp;
  boolean_T c1_e_temp;
  boolean_T c1_f_temp;
  boolean_T c1_g_temp;
  boolean_T c1_h_temp;
  real_T *c1_lap;
  real_T *c1_minutes_out;
  real_T *c1_seconds_out;
  c1_lap = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  _SFD_CS_CALL(STATE_ENTER_DURING_FUNCTION_TAG,5);
  _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,5);
  c1_temp = (_SFD_CCP_CALL(5,0,((_sfEvent_ == c1_event_tick)!=0)) != 0);
  if (c1_temp) {
    c1_b_temp = (_SFD_CCP_CALL(5,1,(((int16_T)chartInstance.c1_seconds == 59)!=0))
                 != 0);
    if (c1_b_temp) {
      c1_b_temp = (_SFD_CCP_CALL(5,2,((*c1_lap != 0.0)!=0)) != 0);
    }

    c1_temp = c1_b_temp;
  }

  if (CV_TRANSITION_EVAL(5U, (int32_T)c1_temp) != 0) {
    if (sf_debug_transition_conflict_check_enabled()) {
      unsigned int transitionList[4];
      unsigned int numTransitions= 1;
      transitionList[0] = 5;
      sf_debug_transition_conflict_check_begin();
      if ((_sfEvent_ == c1_event_tick) && (((int16_T)chartInstance.c1_seconds ==
            59) && (!(*c1_lap != 0.0)))) {
        transitionList[numTransitions] = 3;
        numTransitions++;
      }

      if ((_sfEvent_ == c1_event_tick) && (((int16_T)chartInstance.c1_seconds <
            59) && (*c1_lap != 0.0))) {
        transitionList[numTransitions] = 6;
        numTransitions++;
      }

      if ((_sfEvent_ == c1_event_tick) && (((int16_T)chartInstance.c1_seconds <
            59) && (!(*c1_lap != 0.0)))) {
        transitionList[numTransitions] = 4;
        numTransitions++;
      }

      sf_debug_transition_conflict_check_end();
      if (numTransitions>1) {
        _SFD_TRANSITION_CONFLICT(&(transitionList[0]),numTransitions);
      }
    }

    _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,5);
    _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,5);
    chartInstance.c1_tp_Count = 0U;
    chartInstance.c1_is_Started = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    _SFD_CS_CALL(STATE_INACTIVE_TAG,5);
    _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,5);
    *c1_minutes_out = (real_T)chartInstance.c1_minutes + 1.0;
    _SFD_DATA_RANGE_CHECK(*c1_minutes_out, 1U);
    chartInstance.c1_minutes = c1__u32_add__(chartInstance.c1_minutes,
      c1__u32_s8_(1));
    _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_minutes, 5U);
    chartInstance.c1_seconds = 0U;
    _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
    *c1_seconds_out = 0.0;
    _SFD_DATA_RANGE_CHECK_MIN_MAX(*c1_seconds_out, 2U, 0.0, 59.0);
    chartInstance.c1_is_Started = (uint8_T)c1_IN_Count;
    _SFD_CS_CALL(STATE_ACTIVE_TAG,5);
    chartInstance.c1_tp_Count = 1U;
  } else {
    _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,3);
    c1_c_temp = (_SFD_CCP_CALL(3,0,((_sfEvent_ == c1_event_tick)!=0)) != 0);
    if (c1_c_temp) {
      c1_d_temp = (_SFD_CCP_CALL(3,1,(((int16_T)chartInstance.c1_seconds == 59)
        !=0)) != 0);
      if (c1_d_temp) {
        c1_d_temp = !(_SFD_CCP_CALL(3,2,((*c1_lap != 0.0)!=0)) != 0);
      }

      c1_c_temp = c1_d_temp;
    }

    if (CV_TRANSITION_EVAL(3U, (int32_T)c1_c_temp) != 0) {
      if (sf_debug_transition_conflict_check_enabled()) {
        unsigned int transitionList[3];
        unsigned int numTransitions= 1;
        transitionList[0] = 3;
        sf_debug_transition_conflict_check_begin();
        if ((_sfEvent_ == c1_event_tick) && (((int16_T)chartInstance.c1_seconds <
              59) && (*c1_lap != 0.0))) {
          transitionList[numTransitions] = 6;
          numTransitions++;
        }

        if ((_sfEvent_ == c1_event_tick) && (((int16_T)chartInstance.c1_seconds <
              59) && (!(*c1_lap != 0.0)))) {
          transitionList[numTransitions] = 4;
          numTransitions++;
        }

        sf_debug_transition_conflict_check_end();
        if (numTransitions>1) {
          _SFD_TRANSITION_CONFLICT(&(transitionList[0]),numTransitions);
        }
      }

      _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,3);
      _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,5);
      chartInstance.c1_tp_Count = 0U;
      chartInstance.c1_is_Started = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      _SFD_CS_CALL(STATE_INACTIVE_TAG,5);
      _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,5);
      chartInstance.c1_minutes = c1__u32_add__(chartInstance.c1_minutes,
        c1__u32_s8_(1));
      _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_minutes, 5U);
      chartInstance.c1_seconds = 0U;
      _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
      chartInstance.c1_is_Started = (uint8_T)c1_IN_Count;
      _SFD_CS_CALL(STATE_ACTIVE_TAG,5);
      chartInstance.c1_tp_Count = 1U;
    } else {
      _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,6);
      c1_e_temp = (_SFD_CCP_CALL(6,0,((_sfEvent_ == c1_event_tick)!=0)) != 0);
      if (c1_e_temp) {
        c1_f_temp = (_SFD_CCP_CALL(6,1,(((int16_T)chartInstance.c1_seconds < 59)
          !=0)) != 0);
        if (c1_f_temp) {
          c1_f_temp = (_SFD_CCP_CALL(6,2,((*c1_lap != 0.0)!=0)) != 0);
        }

        c1_e_temp = c1_f_temp;
      }

      if (CV_TRANSITION_EVAL(6U, (int32_T)c1_e_temp) != 0) {
        if (sf_debug_transition_conflict_check_enabled()) {
          unsigned int transitionList[2];
          unsigned int numTransitions= 1;
          transitionList[0] = 6;
          sf_debug_transition_conflict_check_begin();
          if ((_sfEvent_ == c1_event_tick) && (((int16_T)
                chartInstance.c1_seconds < 59) && (!(*c1_lap != 0.0)))) {
            transitionList[numTransitions] = 4;
            numTransitions++;
          }

          sf_debug_transition_conflict_check_end();
          if (numTransitions>1) {
            _SFD_TRANSITION_CONFLICT(&(transitionList[0]),numTransitions);
          }
        }

        _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,6);
        _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,5);
        chartInstance.c1_tp_Count = 0U;
        chartInstance.c1_is_Started = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
        _SFD_CS_CALL(STATE_INACTIVE_TAG,5);
        _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,5);
        *c1_seconds_out = (real_T)chartInstance.c1_seconds + 1.0;
        _SFD_DATA_RANGE_CHECK_MIN_MAX(*c1_seconds_out, 2U, 0.0, 59.0);
        chartInstance.c1_seconds = c1__u8_add__(chartInstance.c1_seconds,
          c1__u8_s8_(1));
        _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
        *c1_minutes_out = (real_T)chartInstance.c1_minutes;
        _SFD_DATA_RANGE_CHECK(*c1_minutes_out, 1U);
        chartInstance.c1_is_Started = (uint8_T)c1_IN_Count;
        _SFD_CS_CALL(STATE_ACTIVE_TAG,5);
        chartInstance.c1_tp_Count = 1U;
      } else {
        _SFD_CT_CALL(TRANSITION_BEFORE_PROCESSING_TAG,4);
        c1_g_temp = (_SFD_CCP_CALL(4,0,((_sfEvent_ == c1_event_tick)!=0)) != 0);
        if (c1_g_temp) {
          c1_h_temp = (_SFD_CCP_CALL(4,1,(((int16_T)chartInstance.c1_seconds <
            59)!=0)) != 0);
          if (c1_h_temp) {
            c1_h_temp = !(_SFD_CCP_CALL(4,2,((*c1_lap != 0.0)!=0)) != 0);
          }

          c1_g_temp = c1_h_temp;
        }

        if (CV_TRANSITION_EVAL(4U, (int32_T)c1_g_temp) != 0) {
          _SFD_CT_CALL(TRANSITION_ACTIVE_TAG,4);
          _SFD_CS_CALL(STATE_ENTER_EXIT_FUNCTION_TAG,5);
          chartInstance.c1_tp_Count = 0U;
          chartInstance.c1_is_Started = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
          _SFD_CS_CALL(STATE_INACTIVE_TAG,5);
          _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,5);
          chartInstance.c1_seconds = c1__u8_add__(chartInstance.c1_seconds,
            c1__u8_s8_(1));
          _SFD_DATA_RANGE_CHECK((real_T)chartInstance.c1_seconds, 4U);
          chartInstance.c1_is_Started = (uint8_T)c1_IN_Count;
          _SFD_CS_CALL(STATE_ACTIVE_TAG,5);
          chartInstance.c1_tp_Count = 1U;
        } else {
          goto label_1;
        }
      }
    }
  }

 label_1:
  ;
  _SFD_CS_CALL(EXIT_OUT_OF_FUNCTION_TAG,5);
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

const mxArray *sf_c1_stopwatch_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  sf_mex_assign(&c1_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c1_nameCaptureInfo;
}

static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  uint8_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((uint8_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 3, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_c_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  boolean_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((boolean_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 11, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_d_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  uint32_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((uint32_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 7, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static uint32_T c1__u32_add__(uint32_T c1_b, uint32_T c1_c)
{
  uint32_T c1_a;
  c1_a = c1_b + c1_c;
  if (c1_a < c1_b) {
    sf_debug_overflow_detection(SFDB_OVERFLOW);
  }

  return c1_a;
}

static uint8_T c1__u8_add__(uint8_T c1_b, uint8_T c1_c)
{
  uint8_T c1_a;
  c1_a = (uint8_T)(c1_b + c1_c);
  if (c1_a < c1_b) {
    sf_debug_overflow_detection(SFDB_OVERFLOW);
  }

  return c1_a;
}

static uint32_T c1__u32_s8_(int8_T c1_b)
{
  uint32_T c1_a;
  c1_a = (uint32_T)c1_b;
  if (c1_b < 0) {
    sf_debug_overflow_detection(SFDB_OVERFLOW);
  }

  return c1_a;
}

static uint8_T c1__u8_s8_(int8_T c1_b)
{
  uint8_T c1_a;
  c1_a = (uint8_T)c1_b;
  if (c1_b < 0) {
    sf_debug_overflow_detection(SFDB_OVERFLOW);
  }

  return c1_a;
}

static void init_test_point_addr_map(void)
{
  chartInstance.c1_testPointAddrMap[0] = &chartInstance.c1_seconds;
  chartInstance.c1_testPointAddrMap[1] = &chartInstance.c1_minutes;
  chartInstance.c1_testPointAddrMap[2] = &chartInstance.c1_mem_seconds;
  chartInstance.c1_testPointAddrMap[3] = &chartInstance.c1_mem_minutes;
  chartInstance.c1_testPointAddrMap[4] = &chartInstance.c1_tp_Memory;
  chartInstance.c1_testPointAddrMap[5] = &chartInstance.c1_tp_Disengaged;
  chartInstance.c1_testPointAddrMap[6] = &chartInstance.c1_tp_Engaged;
  chartInstance.c1_testPointAddrMap[7] = &chartInstance.c1_tp_Watch;
  chartInstance.c1_testPointAddrMap[8] = &chartInstance.c1_tp_Started;
  chartInstance.c1_testPointAddrMap[9] = &chartInstance.c1_tp_Count;
  chartInstance.c1_testPointAddrMap[10] = &chartInstance.c1_tp_Stopped;
}

static void **get_test_point_address_map(void)
{
  return &chartInstance.c1_testPointAddrMap[0];
}

static rtwCAPI_ModelMappingInfo *get_test_point_mapping_info(void)
{
  return &chartInstance.c1_testPointMappingInfo;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
static void init_test_point_mapping_info(SimStruct *S);
void sf_c1_stopwatch_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(583519795U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(956298415U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2822535214U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1645731736U);
}

mxArray *sf_c1_stopwatch_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1361301663U);
    pr[1] = (double)(1604488782U);
    pr[2] = (double)(3742456064U);
    pr[3] = (double)(3627448334U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c1_stopwatch(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x10'type','srcId','name','auxInfo'{{M[1],M[23],T\"minutes_out\",},{M[1],M[24],T\"seconds_out\",},{M[3],M[29],T\"mem_minutes\",},{M[3],M[28],T\"mem_seconds\",},{M[3],M[27],T\"minutes\",},{M[3],M[26],T\"seconds\",},{M[8],M[0],T\"is_active_c1_stopwatch\",},{M[8],M[4],T\"is_active_Watch\",},{M[8],M[5],T\"is_active_Memory\",},{M[9],M[2],T\"is_Started\",}}",
    "100 S1x2'type','srcId','name','auxInfo'{{M[9],M[4],T\"is_Watch\",},{M[9],M[5],T\"is_Memory\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 12, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_stopwatch_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_stopwatchMachineNumber_,
          1,
          7,
          13,
          9,
          1,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_stopwatchMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_stopwatchMachineNumber_,
            chartInstance.chartNumber,0);
          sf_debug_set_chart_event_thresholds(_stopwatchMachineNumber_,
            chartInstance.chartNumber,
            1,
            1,
            1);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_UINT8,0,NULL,0,0,0,0.0,1.0,0,"run",0,
                              (MexFcnForType)c1_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_UINT32,0,NULL,0,0,0,0.0,1.0,0,
                              "minutes_out",0,(MexFcnForType)c1_sf_marshall);
          _SFD_SET_DATA_PROPS(2,2,0,1,SF_UINT8,0,NULL,0,0,0,0.0,1.0,0,
                              "seconds_out",0,(MexFcnForType)c1_sf_marshall);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_UINT8,0,NULL,0,0,0,0.0,1.0,0,"lap",0,
                              (MexFcnForType)c1_sf_marshall);
          _SFD_SET_DATA_PROPS(4,0,0,0,SF_UINT8,0,NULL,0,0,0,0.0,1.0,0,"seconds",
                              0,(MexFcnForType)c1_b_sf_marshall);
          _SFD_SET_DATA_PROPS(5,0,0,0,SF_UINT32,0,NULL,0,0,0,0.0,1.0,0,"minutes",
                              0,(MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(6,0,0,0,SF_UINT8,0,NULL,0,0,0,0.0,1.0,0,
                              "mem_seconds",0,(MexFcnForType)c1_b_sf_marshall);
          _SFD_SET_DATA_PROPS(7,0,0,0,SF_UINT32,0,NULL,0,0,0,0.0,1.0,0,
                              "mem_minutes",0,(MexFcnForType)c1_d_sf_marshall);
          _SFD_SET_DATA_PROPS(8,1,1,0,SF_UINT8,0,NULL,0,0,0,0.0,1.0,0,
                              "store_recall",0,(MexFcnForType)c1_sf_marshall);
          _SFD_EVENT_SCOPE(0,1);
          _SFD_STATE_INFO(0,0,1);
          _SFD_STATE_INFO(1,0,0);
          _SFD_STATE_INFO(2,0,0);
          _SFD_STATE_INFO(3,0,1);
          _SFD_STATE_INFO(4,0,0);
          _SFD_STATE_INFO(5,0,0);
          _SFD_STATE_INFO(6,0,0);
          _SFD_CH_SUBSTATE_COUNT(2);
          _SFD_CH_SUBSTATE_DECOMP(1);
          _SFD_CH_SUBSTATE_INDEX(0,3);
          _SFD_CH_SUBSTATE_INDEX(1,0);
          _SFD_ST_SUBSTATE_COUNT(3,2);
          _SFD_ST_SUBSTATE_INDEX(3,0,4);
          _SFD_ST_SUBSTATE_INDEX(3,1,6);
          _SFD_ST_SUBSTATE_COUNT(4,1);
          _SFD_ST_SUBSTATE_INDEX(4,0,5);
          _SFD_ST_SUBSTATE_COUNT(5,0);
          _SFD_ST_SUBSTATE_COUNT(6,0);
          _SFD_ST_SUBSTATE_COUNT(0,2);
          _SFD_ST_SUBSTATE_INDEX(0,0,1);
          _SFD_ST_SUBSTATE_INDEX(0,1,2);
          _SFD_ST_SUBSTATE_COUNT(1,0);
          _SFD_ST_SUBSTATE_COUNT(2,0);
        }

        _SFD_CV_INIT_CHART(2,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,2,1,0,0,0,NULL,NULL);
        }

        {
          _SFD_CV_INIT_STATE(1,0,0,0,0,0,NULL,NULL);
        }

        {
          _SFD_CV_INIT_STATE(2,0,0,0,0,0,NULL,NULL);
        }

        {
          _SFD_CV_INIT_STATE(3,2,1,0,0,0,NULL,NULL);
        }

        {
          _SFD_CV_INIT_STATE(4,1,0,0,0,0,NULL,NULL);
        }

        {
          _SFD_CV_INIT_STATE(5,0,0,0,0,0,NULL,NULL);
        }

        {
          _SFD_CV_INIT_STATE(6,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        {
          static unsigned int sStartGuardMap[] = { 1 };

          static unsigned int sEndGuardMap[] = { 4 };

          static int sPostFixPredicateTree[] = { 0 };

          _SFD_CV_INIT_TRANS(1,1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),1,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 2 };

          static unsigned int sEndGuardMap[] = { 5 };

          static int sPostFixPredicateTree[] = { 0, -1 };

          _SFD_CV_INIT_TRANS(2,1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),2,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 0, 6, 22 };

          static unsigned int sEndGuardMap[] = { 4, 17, 25 };

          static int sPostFixPredicateTree[] = { 0, 1, 2, -1, -3, -3 };

          _SFD_CV_INIT_TRANS(3,3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),6,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 0, 6, 20 };

          static unsigned int sEndGuardMap[] = { 4, 16, 23 };

          static int sPostFixPredicateTree[] = { 0, 1, 2, -1, -3, -3 };

          _SFD_CV_INIT_TRANS(4,3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),6,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 0, 6, 21 };

          static unsigned int sEndGuardMap[] = { 4, 17, 24 };

          static int sPostFixPredicateTree[] = { 0, 1, 2, -3, -3 };

          _SFD_CV_INIT_TRANS(5,3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),5,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 0, 6, 19 };

          static unsigned int sEndGuardMap[] = { 4, 16, 22 };

          static int sPostFixPredicateTree[] = { 0, 1, 2, -3, -3 };

          _SFD_CV_INIT_TRANS(6,3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),5,
                             &(sPostFixPredicateTree[0]));
        }

        _SFD_CV_INIT_TRANS(7,0,NULL,NULL,0,NULL);

        {
          static unsigned int sStartGuardMap[] = { 2 };

          static unsigned int sEndGuardMap[] = { 14 };

          static int sPostFixPredicateTree[] = { 0, -1 };

          _SFD_CV_INIT_TRANS(8,1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),2,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 1 };

          static unsigned int sEndGuardMap[] = { 13 };

          static int sPostFixPredicateTree[] = { 0 };

          _SFD_CV_INIT_TRANS(9,1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),1,
                             &(sPostFixPredicateTree[0]));
        }

        {
          static unsigned int sStartGuardMap[] = { 1 };

          static unsigned int sEndGuardMap[] = { 13 };

          static int sPostFixPredicateTree[] = { 0 };

          _SFD_CV_INIT_TRANS(10,1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),1,
                             &(sPostFixPredicateTree[0]));
        }

        _SFD_CV_INIT_TRANS(11,0,NULL,NULL,0,NULL);
        _SFD_CV_INIT_TRANS(12,0,NULL,NULL,0,NULL);
        _SFD_TRANS_COV_WTS(0,0,0,0,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(1,0,1,0,4);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 1 };

          static unsigned int sEndGuardMap[] = { 4 };

          _SFD_TRANS_COV_MAPS(1,
                              0,NULL,NULL,
                              1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              4,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(2,0,1,0,0);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 2 };

          static unsigned int sEndGuardMap[] = { 5 };

          _SFD_TRANS_COV_MAPS(2,
                              0,NULL,NULL,
                              1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(3,0,3,0,2);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 0, 6, 22 };

          static unsigned int sEndGuardMap[] = { 4, 17, 25 };

          _SFD_TRANS_COV_MAPS(3,
                              0,NULL,NULL,
                              3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              2,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(4,0,3,0,1);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 0, 6, 20 };

          static unsigned int sEndGuardMap[] = { 4, 16, 23 };

          _SFD_TRANS_COV_MAPS(4,
                              0,NULL,NULL,
                              3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              1,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(5,0,3,0,4);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 0, 6, 21 };

          static unsigned int sEndGuardMap[] = { 4, 17, 24 };

          _SFD_TRANS_COV_MAPS(5,
                              0,NULL,NULL,
                              3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              4,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(6,0,3,0,3);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 0, 6, 19 };

          static unsigned int sEndGuardMap[] = { 4, 16, 22 };

          _SFD_TRANS_COV_MAPS(6,
                              0,NULL,NULL,
                              3,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              3,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(7,0,0,0,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(7,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(8,0,1,0,4);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 2 };

          static unsigned int sEndGuardMap[] = { 14 };

          _SFD_TRANS_COV_MAPS(8,
                              0,NULL,NULL,
                              1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              4,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(9,0,1,0,2);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 1 };

          static unsigned int sEndGuardMap[] = { 13 };

          _SFD_TRANS_COV_MAPS(9,
                              0,NULL,NULL,
                              1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              2,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(10,0,1,0,0);
        if (chartAlreadyPresent==0) {
          static unsigned int sStartGuardMap[] = { 1 };

          static unsigned int sEndGuardMap[] = { 13 };

          _SFD_TRANS_COV_MAPS(10,
                              0,NULL,NULL,
                              1,&(sStartGuardMap[0]),&(sEndGuardMap[0]),
                              0,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(11,0,0,0,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(11,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_TRANS_COV_WTS(12,0,0,0,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(12,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c1_run;
          real_T *c1_minutes_out;
          real_T *c1_seconds_out;
          real_T *c1_lap;
          real_T *c1_store_recall;
          c1_lap = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          c1_run = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          c1_minutes_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c1_seconds_out = (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
          c1_store_recall = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_run);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_minutes_out);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_seconds_out);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_lap);
          _SFD_SET_DATA_VALUE_PTR(4U, &chartInstance.c1_seconds);
          _SFD_SET_DATA_VALUE_PTR(5U, &chartInstance.c1_minutes);
          _SFD_SET_DATA_VALUE_PTR(6U, &chartInstance.c1_mem_seconds);
          _SFD_SET_DATA_VALUE_PTR(7U, &chartInstance.c1_mem_minutes);
          _SFD_SET_DATA_VALUE_PTR(8U, c1_store_recall);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_stopwatchMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c1_stopwatch(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c1_stopwatch();
  initialize_c1_stopwatch();
}

static void sf_opaque_enable_c1_stopwatch(void *chartInstanceVar)
{
  enable_c1_stopwatch();
}

static void sf_opaque_disable_c1_stopwatch(void *chartInstanceVar)
{
  disable_c1_stopwatch();
}

static void sf_opaque_gateway_c1_stopwatch(void *chartInstanceVar)
{
  sf_c1_stopwatch();
}

static mxArray* sf_opaque_get_sim_state_c1_stopwatch(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c1_stopwatch();
  return st;
}

static void sf_opaque_set_sim_state_c1_stopwatch(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c1_stopwatch(sf_mex_dup(st));
}

static void sf_opaque_terminate_c1_stopwatch(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c1_stopwatch();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_stopwatch(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_stopwatch();
  }
}

static void mdlSetWorkWidths_c1_stopwatch(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("stopwatch","stopwatch",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("stopwatch","stopwatch",1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("stopwatch","stopwatch",1,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"stopwatch","stopwatch",1,3);
      sf_mark_chart_reusable_outputs(S,"stopwatch","stopwatch",1,2);
    }

    ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
    sf_set_rtw_dwork_info(S,"stopwatch","stopwatch",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3077717505U));
  ssSetChecksum1(S,(2153489078U));
  ssSetChecksum2(S,(1701001293U));
  ssSetChecksum3(S,(3034906794U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_stopwatch(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "stopwatch", "stopwatch",1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Stateflow");
  }
}

static void mdlStart_c1_stopwatch(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 0;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c1_stopwatch;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c1_stopwatch;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c1_stopwatch;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_stopwatch;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_stopwatch;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c1_stopwatch;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c1_stopwatch;
  chartInstance.chartInfo.getSimStateInfo = sf_get_sim_state_info_c1_stopwatch;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_stopwatch;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_stopwatch;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_stopwatch;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_test_point_mapping_info(S);
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c1_stopwatch_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_stopwatch(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_stopwatch(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_stopwatch(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_stopwatch_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}

static const rtwCAPI_DataTypeMap dataTypeMap[] = {
  /* cName, mwName, numElements, elemMapIndex, dataSize, slDataId, isComplex, isPointer */
  { "uint32_T", "uint32_T", 0, 0, sizeof(uint32_T), SS_UINT32, 0, 0 },

  { "uint8_T", "uint8_T", 0, 0, sizeof(uint8_T), SS_UINT8, 0, 0 } };

static const rtwCAPI_FixPtMap fixedPointMap[] = {
  /* *fracSlope, *bias, scaleType, wordLength, exponent, isSigned */
  { NULL, NULL, rtwCAPI_FIX_RESERVED, 64, 0, 0 } };

static const rtwCAPI_DimensionMap dimensionMap[] = {
  /* dataOrientation, dimArrayIndex, numDims*/
  { rtwCAPI_SCALAR, 0, 2 } };

static const uint_T dimensionArray[] = {
  1, 1 };

static real_T sfCAPIsampleTimeZero = 0.0;
static const rtwCAPI_SampleTimeMap sampleTimeMap[] = {
  /* *period, *offset, taskId, mode */
  { &sfCAPIsampleTimeZero, &sfCAPIsampleTimeZero, 0, 0 }
};

static const rtwCAPI_Signals testPointSignals[] = {
  /* addrMapIndex, sysNum, SFRelativePath, dataName, portNumber, dataTypeIndex, dimIndex, fixPtIdx, sTimeIndex */
  { 0, 0, "StateflowChart/seconds", "seconds", 0, 1, 0, 0, 0 },

  { 1, 0, "StateflowChart/minutes", "minutes", 0, 0, 0, 0, 0 },

  { 2, 0, "StateflowChart/mem_seconds", "mem_seconds", 0, 1, 0, 0, 0 },

  { 3, 0, "StateflowChart/mem_minutes", "mem_minutes", 0, 0, 0, 0, 0 },

  { 4, 0, "StateflowChart/Memory", "Memory", 0, 1, 0, 0, 0 },

  { 5, 0, "StateflowChart/Memory.Disengaged", "Disengaged", 0, 1, 0, 0, 0 },

  { 6, 0, "StateflowChart/Memory.Engaged", "Engaged", 0, 1, 0, 0, 0 },

  { 7, 0, "StateflowChart/Watch", "Watch", 0, 1, 0, 0, 0 },

  { 8, 0, "StateflowChart/Watch.Started", "Started", 0, 1, 0, 0, 0 },

  { 9, 0, "StateflowChart/Watch.Started.Count", "Count", 0, 1, 0, 0, 0 },

  { 10, 0, "StateflowChart/Watch.Stopped", "Stopped", 0, 1, 0, 0, 0 } };

static rtwCAPI_ModelMappingStaticInfo testPointMappingStaticInfo = {
  /* block signal monitoring */
  {
    testPointSignals,                  /* Block signals Array  */
    11                                 /* Num Block IO signals */
  },

  /* parameter tuning */
  {
    NULL,                              /* Block parameters Array    */
    0,                                 /* Num block parameters      */
    NULL,                              /* Variable parameters Array */
    0                                  /* Num variable parameters   */
  },

  /* block states */
  {
    NULL,                              /* Block States array        */
    0                                  /* Num Block States          */
  },

  /* Static maps */
  {
    dataTypeMap,                       /* Data Type Map            */
    dimensionMap,                      /* Data Dimension Map       */
    fixedPointMap,                     /* Fixed Point Map          */
    NULL,                              /* Structure Element map    */
    sampleTimeMap,                     /* Sample Times Map         */
    dimensionArray                     /* Dimension Array          */
  },

  /* Target type */
  "float"
};

static void init_test_point_mapping_info(SimStruct *S)
{
  rtwCAPI_ModelMappingInfo *testPointMappingInfo;
  void **testPointAddrMap;
  init_test_point_addr_map();
  testPointMappingInfo = get_test_point_mapping_info();
  testPointAddrMap = get_test_point_address_map();
  rtwCAPI_SetStaticMap(*testPointMappingInfo, &testPointMappingStaticInfo);
  rtwCAPI_SetLoggingStaticMap(*testPointMappingInfo, NULL);
  rtwCAPI_SetInstanceLoggingInfo(*testPointMappingInfo, NULL);
  rtwCAPI_SetPath(*testPointMappingInfo, "");
  rtwCAPI_SetFullPath(*testPointMappingInfo, NULL);
  rtwCAPI_SetDataAddressMap(*testPointMappingInfo, testPointAddrMap);
  rtwCAPI_SetChildMMIArray(*testPointMappingInfo, NULL);
  rtwCAPI_SetChildMMIArrayLen(*testPointMappingInfo, 0);
  ssSetModelMappingInfoPtr(S, testPointMappingInfo);
}
